/**
 * 移動可能Window用共通ライブラリ
 * movingwin.js
 *
 * $Id: movingwin.js,v 1.3 2006/03/11 14:31:37 shio Exp $
 */

var movingWinInfo = new Object();

movingWinInfo.add = function(elmid, top, left, eventElmid) {
    movingWinInfo[elmid] = new MovingWin(elmid, top, left, eventElmid);
}

document.onmouseup = function() {
    document.onmousemove = function() {};
}

function MovingWin(elmid, top, left, eventElmid) {
    this.top = top;
    this.left = left;
    this.startTop = this.top;
    this.startLeft = this.left;
    this.elmid = elmid;
    this.onMouseMove = movingWinOnMouseMove;
    this.onMouseDown = movingWinOnMouseDown;
    this.eventElmid = (eventElmid) ? eventElmid : elmid; 
    this.disp = function() {
        var elm = document.getElementById(this.elmid);
        elm.style.top = this.top + "px";
        elm.style.left = this.left + "px";
        elm.style.display = "block";
        var elmevent = document.getElementById(this.eventElmid);
		elmevent.setAttribute("targetid", this.elmid);
        elmevent.onmousedown = this.onMouseDown;
    }
}

function movingWinOnMouseMove(event) {
    if (! event) {
        event = window.event;
    }
    var target = movingWinInfo.target;
    var newtop = target.startTop + event.clientY - target.startY;
    var newleft = target.startLeft + event.clientX - target.startX;
    if ( (Math.abs(newtop - target.top) + Math.abs(newleft - target.left) ) > 100) {
        return;
    }
    target.top = newtop;
    target.left = newleft;
    var elm = document.getElementById(target.elmid);
    elm.style.top = target.top + "px";
    elm.style.left = target.left + "px";
}

function movingWinOnMouseDown(event) {
    if (! event) {
        event = window.event;
    }
	if (! event.currentTarget) {
		return;
	}
	var targetid = event.currentTarget.getAttribute("targetid");
	if (! targetid) {
		return;
    }
    movingWinInfo.target = movingWinInfo[targetid];
    var target = movingWinInfo.target;
    
    target.startY = event.clientY;
    target.startX = event.clientX;
    target.startTop = target.top;
    target.startLeft = target.left;
    
    document.onmousemove = target.onMouseMove;
}
