// 得点表示クラス
function clickDispPoints() {
    if (app.selectMode) {
        app.finishSelectMode();
        cancelSCmd();
    }
    var e = document.getElementById("subWindow");
    var body =  document.getElementById("subBody");
    var width = 350;
    var height = 300;
	var imgfile = (isIE()) ? "subwin3.gif" : "subwin3.png";
    app.subWinData.width = width;
    app.subWinData.height = height;

    e.style.width = width + "px";
    e.style.height = height + "px";

    var windowTitle = document.getElementById("windowTitle");
    document.getElementById("windowTitleText").innerHTML="得点状況";

    var img = document.getElementById("subwinimg");
    img.setAttribute("src", imgfile);
    var pointList = makePointList();
    var str = '<div id="sub_name" style="width: 345px; height: 250px">';
    str += "<table bgcolor='ffffff' class='pointTable' style='font-size: 12px;'>";
    str += "<tr bgcolor='000000'>";
    str += "<th>順位</th>";
    str += "<th>国名</th>";
    str += "<th>合計</th>";
    str += "<th>開発(1)</th>";
//    str += "<th>経済(1)</th>";
    str += "<th>技術(5)</th>";
    str += "<th>植民(3)</th>";
    str += "</tr>";
    var ue = app.empireList[0];
    for (var i = 0; i < pointList.length; i++) {
        var p = pointList[i];
        if (BLACK_MODE && (p.empire.id != ue.id) && (! ue.yoronList[p.empire.id]) ) {
            continue;
        }
        str += "<tr bgcolor='" + p.empire.color + "'  style='font-size: 12px;'>";
        str += "<td align='center'>" + p.juni + "</td>";
        str += "<td>" + p.empire.name + (p.isDestroyed() ? "滅亡" : "") + "</td>";
        str += "<td align='center'>" + p.totalPoint() + "</td>";
        str += "<td align='center'>" + p.totalDplMsg() + "</td>";
//        str += "<td align='center'>" + p.totalEcnMsg() + "</td>";
        str += "<td align='center'>" + p.tecMsg() + "</td>";
        str += "<td align='center'>" + p.colonyMsg() + "</td>";
        str += "</tr>";
    }
    str += "</table>";
    str += '</div>';

    body.innerHTML = str;
    movingWinInfo.subWindow.disp();
    document.getElementById("sub_name").width = (width - 20) + "px";
}

// 順位表を表示する
function makePointList() {
    var pointList = new Array();
    for (var i = 0; i < app.empireList.length; i++) {
        var empire = app.empireList[i];
        pointList.push(new Point(empire) );
    }

    for (var i = 0; i < pointList.length - 1; i++) {
        var p1 = pointList[i];
        var tp1 = p1.totalPoint();
        for (var j = i+1; j < pointList.length; j++) {
            var p2 = pointList[j];
            var tp2 = p2.totalPoint();
            if (tp1 > tp2) {
                p2.juni++;
            } else if (tp1 < tp2) {
                p1.juni++;
            }
        }
    }

    var resultList = new Array();
    resultList.length = pointList.length;
    for (var i = 0; i < pointList.length; i++) {
        var p = pointList[i];
        for (var j = p.juni - 1; j < pointList.length; j++) {
            if (! resultList[j]) {
                resultList[j] = p;
                break;
            }
        }
    }

    return resultList;
}

function Point(empire) {
    this.empire = empire;
    this.juni = 1;

    // 滅亡判定
    this.isDestroyed = function() {
        return (this.empire.totalDpl() == 0);
    }

    // 開発得点
    this.totalDplPoint = function() {
        return this.empire.totalDpl();
    }

    // 開発得点メッセージ
    this.totalDplMsg = function() {
        return this.totalDplPoint()
                + "(" + this.empire.totalDpl() + ")";
    }

    // 経済力得点
    this.totalEcnPoint = function() {
        if (this.isDestroyed()) {
            return 0;
        }
        return this.empire.totalEcn();
    }

    // 経済力得点メッセージ
    this.totalEcnMsg = function() {
        if (this.isDestroyed()) {
            return "0(0)";
        }
        return this.totalEcnPoint()
                + "(" + this.empire.totalEcn() + ")";
    }

    // 技術得点
    this.tecPoint = function() {
        if (this.isDestroyed()) {
            return 0;
        }
        return (this.empire.fnd + this.empire.nvg + this.empire.mlt) * 5;
    }

    // 技術得点メッセージ
    this.tecMsg = function() {
        if (this.isDestroyed()) {
            return 0;
        }
        return this.tecPoint()
                + "(" + this.empire.fnd
                + "-" + this.empire.nvg
                + "-" + this.empire.mlt + ")";
    }

    // 植民得点
    this.colonyPoint = function() {
        return this.countColony() * 3;
    }

    // 植民惑星を数える
    this.countColony = function() {
        if (this.isDestroyed()) {
            return 0;
        }
        var plist = this.empire.ctlPlanetList;
        var point = 0;
        for (var i = 0; i < plist.length; i++) {
            var p = plist[i];
            if (p.dpl > 0) {
                point++;
            }
        }
        return point;
    }

    // 植民得点メッセージ
    this.colonyMsg = function() {
        return this.colonyPoint()
                + "(" + this.countColony() + ")";
    }

    // 総得点
    this.totalPoint = function() {
        if (this.isDestroyed()) {
            return 0;
        }
        var result = 0;
        result += this.totalDplPoint();
//        result += this.totalEcnPoint();
        result += this.tecPoint();
        result += this.colonyPoint();
        return result;
    }
}