/**
 * Stars! 
 * 初期配置処理
 *
 * $Id: stars_setup.js,v 1.9 2006/03/11 14:31:37 shio Exp $
 */

// Star! 初期配置処理
NEAREST_DISTANCE = 3;
INTERVAL_EMPIRES = 15;
function setup() {
    var createdFlag = false;
    while (! createdFlag) {
        app.empireList = new Array();   // 星間国家リスト
        app.starList = new Object();    // 惑星リスト
        createStars();
        var placableList = makePlacableList();
        var empireList = makeEmpireList();
        app.empireList = empireList;
        for(var i = 0; i < 10; i++) {
            if (placeEmpire() ) {
                createdFlag = true;
                break;
            }
        }
    }

    function placeEmpire() {
        var locList = placableList.randomize();
        var startStarList = new Array();
        locix = 0;
        for (var ix = 0; ix < empireList.length; ix++) {
            var e = empireList[ix];
            if (ix == 0) {
                e.trs = app.startPop * 10;
            } else {
                e.trs = 50;
            }
            for (; locix < locList.length; locix++) {
                var loc = locList[locix];
                if (checkInterval(startStarList, loc) ) {
                    startStarList.push(loc);
                    break;
                }
            }
        }
        if (locix >= locList.length) {
            return false;
        }
        for (var ix = 0; ix < startStarList.length; ix++) {
            var e = empireList[ix];
            loc = startStarList[ix];
            if (ix == 0) {
                app.starList[loc]
                        = new Planet(app.starList[loc].id, loc, e.name,
                            e, app.startPop, app.startPop, app.startPop);
            } else {
                app.starList[loc]
                        = new Planet(app.starList[loc].id,
                            loc, e.name, e, 5, 5, 5);
            }
            e.newctl(app.starList[loc]);
        }
        return true;
    }

    function makeEmpireList() {
        var list = new Array();

        // 国家を配置する
        var id = 1;
        var e = new Empire(id++, "Earth", "#FF0000", 1, 1, 1, 0, true);
        list.push(e);

        e = new Empire(id++, "Tranter", "#00AA00", 1, 1, 1, 0, false);
        list.push(e);

        e = new Empire(id++, "Oringan", "#0000FF", 1, 1, 1, 0, false);
        list.push(e);

        e = new Empire(id++, "Sary", "#CC7700", 1, 1, 1, 0, false);
        list.push(e);

        e = new Empire(id++, "Trkamis", "#00CCCC", 1, 1, 1, 0, false);
        list.push(e);

        e = new Empire(id++, "Nord", "#EE00EE", 1, 1, 1, 0, false);
        list.push(e);

        e = new Empire(id++, "Gemis", "#888888", 1, 1, 1, 0, false);
        list.push(e);

        e = new Empire(id++, "Yizujar", "#88DD00", 1, 1, 1, 0, false);
        list.push(e);

        return list;
    }

    // 星を作成する
    function createStars() {
        var id = 1;
        for (var row = 0; row < this.height; row++) {
            for (var col = 0; col < this.width; col++) {
                var lk = makeLocationKey(row, col);
                var isStar = this.desideStar(RATE);
                app.spaceMap[lk] = isStar;
                var nix = (id - 1) % starNameList.length;
                if (isStar) {
                    app.starList[lk] = new Planet(id, lk, starNameList[nix]);
                    id += 1;
                }
            }
        }
    }

    // 配置可能な星のリストを作成する。
    function makePlacableList() {
        var list = new Array();
        var locList = keys(app.starList);
        for (i = 0; i < locList.length; i++) {
            var s1 = locList[i];
            for (j = 0; j < locList.length; j++) {
                if (i == j) {
                    continue;
                }
                var s2 = locList[j];
                if (calDistance(s1, s2) <= NEAREST_DISTANCE) {
                    list.push(s1);
                    break;
                }
            }
        }

        return list;
    }

    // 帝国間の距離をチェックする。
    function checkInterval(startStarList, star) {
        for (var ix = 0; ix < startStarList.length; ix++) {
            if (calDistance(star, startStarList[ix]) < INTERVAL_EMPIRES) {
                return false;
            }
        }
        return true;
    }
}
/**
 * 難易度選択画面
 */
function selectGame() {
    app.startWinEnable = true;
    app.subWinData.pid = null;

    var e = document.getElementById("startWindow");
    var body =  document.getElementById("startSubBody");
    var width = 250;
    var height = 120;
    var x = 100;
    var y = 150;
	var imgfile = (isIE()) ? "subwin1.gif" : "subwin1.png";
    var img = document.getElementById("selectimg");
    img.setAttribute("src", imgfile);

    if (! e.style.left) {
        e.style.left = x + "px";
    }
    if (! e.style.top) {
        e.style.top = y + "px";
    }
    e.style.width = width + "px";

    var str = '<table id="selectTable"><tr>';
    str += '<td align="center" width="' + width + '" style="font-size: 14px;">';
    str += '難易度を選択してください。<br/>';
    str += '</td></tr>';
    str += '<tr><td align="center">';
    str += '<select name="difficulty">';
    str += '<option value="1">簡単</option>';
    str += '<option value="2" selected="selected">普通</option>';
    str += '<option value="3">困難</option>';
    str += '<option value="4">至難</option>';
    str += '</select>';
    str += '<br/>';
    str += '</td></tr>';
    str += '<tr><td align="center">';
    str += '<img src="start.png" onclick="return gameStart();"'
    str += ' alt="START" class="startButton"/>';
    str += '</td></tr></table>';
    body.innerHTML = str;
    e.style.display = "inline";

}

function gameStart() {
    var e = document.getElementById("startWindow");
    var difficulty = document.forms.startForm.difficulty.value;
    app.startPop = 6 - (parseInt(difficulty) - 1);
    app.difficulty = difficulty;
    e.style.display = "none";
 
    if (startWinEnable) {
        app.startWinEnable = false;
        setTimeout("clickCreateMap()", 0);
    }
}


