/**
 * Stars!
 * stars_subwin.js 惑星サブウインドウ処理
 *
 * $Id: stars_subwin.js,v 1.15 2006/03/26 10:37:00 shio Exp $
 */

/**
 * 惑星サブウインドウデータ保持クラス
 */
function SubWinData() {
    this.init = function() {
        this.pid = null;
        this.cmd = new CmdNothing();
        this.scmd = new CmdNothing();
        if (! document.forms) {
            if (! document.forms.subForm.pcmd) {
                document.forms.subForm.pcmd.value = "";
            }
            if (! document.forms.subForm.scmd) {
                document.forms.subForm.scmd.value = "";
            }
        }
    }

    this.init();

    this.setPid = function(pid) {
        this.init();
        this.pid = pid;
    }

}

/**
 * 惑星をクリックしたときのアクション
 */
function clickPlanet(pid) {
    var e = document.getElementById("subWindow");
    var p = app.starList[pid];
    var settler = app.settlerMap[pid];
    var body =  document.getElementById("subBody");
    var width = 300;
    var height = 300;
    var imgfile = (isIE()) ? "subwin2.gif" : "subwin2.png";

    app.subWinData.width = width;
    app.subWinData.height = height;

    app.subWinData.setPid(pid);

    e.style.width = width + "px";
    e.style.height = height + "px";
    
    var windowTitle = document.getElementById("windowTitle");
    document.getElementById("windowTitleText").innerHTML="コマンド選択";

    var img = document.getElementById("subwinimg");
    img.setAttribute("src", imgfile);
    var str = '<div id="sub_name" style="width: 295px; height: 250px">';
    str += "<table>";

    if (p) {
        str += "<tr><th colspan='2' style='text-align: left;'>惑星コマンド選択</th></tr>";
        str += "<tr><td>惑星名</td><td ><span id='planetName'></span></td></tr>";
        str += "<tr><td>人口</td><td><span id='planetDpl'></span></td></tr>";
        str += "<tr><td>経済</td><td><span id='planetEcn'></span></td></tr>";
        str += "<tr><td>防衛</td><td><span id='planetDfc'></span></td></tr>";
        str += "<tr><td>商圏</td><td><span id='planetShoken'></span></td></tr>";
        str += "<tr><td>艦隊</td><td><span id='planetFleet'></span></td></tr>";
        str += "<tr><td>コマンド</td><td><span id='planetCmd'></span><td></tr>";
        str += "<tr><td>コスト</td><td><span id='planetCmdCost'></span></td></tr>";
    }

    if (settler >= 0) {
        str += "<tr><th colspan='2' style='text-align: left;'>移民船団コマンド選択</th></tr>";
        str += "<tr><td>コマンド</td><td><span id='settlerCmd'></span><td></tr>";
        str += "<tr><td>コスト</td><td><span id='settlerCmdCost'></span></td></tr>";
    }

    str += "<tr><td colspan='2'></td></tr>";
    str += "<tr><td>残予算</td><td><span id='zanyosan'></span></td></tr>";
    str += "</table>";

    str += '</div>';
    body.innerHTML = str;
    movingWinInfo.subWindow.disp();
    
    if (p) {
        dispPName(pid);
        dispPElement(pid, "planetDpl", "dpl");
        dispPElement(pid, "planetEcn", "ecn");
        dispPElement(pid, "planetDfc", "dfc");
        dispPElementFunc(pid, "planetShoken", "shogyoKenTotalDpl");
        dispFleet(pid)
        dispPCmd(pid);
    }

    if (settler >= 0) {
        dispSCmd(pid);
    }
    dispZanyosan();
}

/**
 * 全部の入力を確定する
 */
function setAllInput() {
    setPName();
    setPCmd();
}

/**
 * サブウインドウの閉じるボタンを押したときの処理
 */
function clickCloseSub() {
    var e = document.getElementById("subWindow");
    e.style.display = "none";
    app.subWinData.pid = null;
    return;
}

function isDispSub() {
    var e = document.getElementById("subWindow");
    return (e.style.display != "none");
}

/**
 * 惑星名を表示する処理
 * @param pid 惑星の位置(r9c9)
 */
function dispPName(pid) {
    var p = app.starList[pid];
    var pne = document.getElementById("planetName");
    pne.innerHTML = "<a href='javascript:inputPName(\""
            + pid + "\")'>" + p.name + "</a>";
}

/**
 * 惑星名をクリックした時（入力開始）の処理
 * @param pid 惑星の位置(r9c9)
 */
function inputPName(pid) {
    setAllInput();
    var p = app.starList[pid];
    var pne = document.getElementById("planetName");
    pne.innerHTML = "<input type='text' id='inputPName' value=\""
            + p.name + "\" onchange='commitPName()'"
            + " onblur='commitPName()'/>";
}

/**
 * 惑星名を設定したときの処理
 * @param obj 惑星名を設定したinputタグのオブジェクト
 * @param pid 惑星の位置(r9c9)
 */
function setPName() {
    var pid = app.subWinData.pid;
    var p = app.starList[pid];
    var obj = document.getElementById("inputPName");
    if (obj) {
        p.name = obj.value;
    }
}

function commitPName() {
    setPName();
    var pid = app.subWinData.pid;
    dispPName(pid);
}

/**
 * 艦隊を表示する
 */
function dispFleet(pid) {
    var p = app.starList[pid];
    var pne = document.getElementById("planetFleet");
    var fleet = p.ctl.getFleetByPlanetId(p.id);
    var str = "";
    if (fleet) {
        str += "第" + fleet.no + "艦隊";
    } else {
        str += "-";
    }
    pne.innerHTML = str;
}

/**
 * 現在のコマンドを表示する
 *
 */
function dispPCmd(pid) {
    var p = app.starList[pid];
    var cmd = p.getCommand();
    var pne = document.getElementById("planetCmd");
    pne.innerHTML = "<a href='javascript:inputPCmd(\""
            + pid + "\")'>" + cmd.getFullName() + "</a>";
    pne = document.getElementById("planetCmdCost");
    pne.innerHTML = cmd.cost();
    if (document.forms.subForm.pcmd) {
        document.forms.subForm.pcmd.value = cmd.makeKey();
    }
}

/**
 * コマンドをクリックした時（入力開始）の処理
 * @param pid 惑星の位置(r9c9)
 */
function inputPCmd(pid) {
    var p = app.starList[pid];
    var pne = document.getElementById("planetCmd");
    var cmd = p.getCommand();
    if (cmd) {
        app.subWinData.cmd = cmd;
    } else {
        app.subWinData.cmd = new CmdNothing(p.ctl, p);
    }
    var cmdList = app.userAgent.getCmdList(p.ctl, p.loc);
    var html = "<select onchange='commitPCmd()' "
            + "onblur='commitPCmd()' name='pcmd'>";
    html += "<option value='0'>なし</option>";
    html += app.userAgent.getCmdOptions(cmdList, app.subWinData.cmd);
    html += "</select>";
    pne.innerHTML = html;
    setAllInput();
}

/**
 * コマンドを設定したときの処理
 */
function setPCmd() {
    var p = app.starList[app.subWinData.pid];
    if (! p) {
        return;
    }
    var orgCmd = p.getCommand();
    if (document.forms.subForm.pcmd) {
        if (orgCmd) {
            p.ctl.tmp_trs += orgCmd.cost();
        }
        var ary = document.forms.subForm.pcmd.value.split(/-/);
        var cmd_id = parseInt(ary[0]);
        var target = getPlanetById(parseInt(ary[1]));
        app.subWinData.cmd = getCmdById(cmd_id, p.ctl, p, target);
//        app.subWinData.cmd.think(app.userAgent, p);
        p.setCmd(app.subWinData.cmd);
        p.ctl.tmp_trs -= app.subWinData.cmd.cost();
        dispZanyosan();
    }
}

function commitPCmd() {
    setPCmd();
    dispPCmd(app.subWinData.pid);
}
/**
 * 惑星の属性を表示する
 * @param pid 惑星の位置(r9c9)
 * @param eid 表示位置elementのid
 * @param ix 表示する属性名
 */
function dispPElement(pid, eid, ix) {
    var p = app.starList[pid];
    var pe = document.getElementById(eid);
    pe.innerHTML = p[ix];
}

/**
 * 惑星のメソッドを呼び出して、その結果を表示する
 * @param pid 惑星の位置(r9c9)
 * @param eid 表示位置elementのid
 * @param ix 表示する属性名
 */
function dispPElementFunc(pid, eid, ix) {
    var p = app.starList[pid];
    var pe = document.getElementById(eid);
    pe.innerHTML = p[ix]();
}


/**
 * 現在の移民船団コマンドを表示する
 *
 */
function dispSCmd(pid) {
    var s = app.settlerMap[pid];
    var cmd = app.getSettlerCmd(pid);
    var se = document.getElementById("settlerCmd");
    se.innerHTML = "<a href='javascript:inputSCmd(\""
            + pid + "\")'>" + cmd.getFullName() + "</a>";
    se = document.getElementById("settlerCmdCost");
    se.innerHTML = cmd.cost();
    if (document.forms.subForm.scmd) {
        document.forms.subForm.scmd.value = cmd.makeKey();
    }
}

/**
 * 移民船団コマンドをクリックした時（入力開始）の処理
 * @param pid 位置(r9c9)
 */
function inputSCmd(pid) {
    var sid = app.settlerMap[pid];
    var empire = app.empireList[sid];
    var se = document.getElementById("settlerCmd");
    var cmd = app.getSettlerCmd(pid);
    if (cmd) {
        app.subWinData.cmd = cmd;
    } else {
        app.subWinData.cmd = new CmdNothing(empire, pid);
    }
    var cmdList = app.userAgent.getSettlerCmdList(empire, pid);
    var html = "<select onchange='commitSCmd()' "
            + "onblur='commitSCmd()' name='scmd' id='selectScmd'>";
    html += "<option value='0'>なし</option>";
    html += app.userAgent.getSettlerCmdOptions(cmdList, app.subWinData.scmd);
    html += "</select>";
    se.innerHTML = html;
    setAllInput();
}

/**
 * 移民船団コマンドを設定したときの処理
 */
function setSCmd() {
    var pid = app.subWinData.pid;
    var sid = app.settlerMap[pid];
    if (!(sid >= 0)) {
        return;
    }
    var empire = app.empireList[sid];
    var orgCmd = app.getSettlerCmd(app.subWinData.pid);
    var elm = document.getElementById('selectScmd');
    if (elm) {
        if (orgCmd) {
            empire.tmp_trs += orgCmd.cost();
        }
        var ary = elm.value.split(/-/);
        var cmd_id = parseInt(ary[0]);
        var target = ary[1];
        app.subWinData.scmd = getSettlerCmdById(cmd_id, empire, pid, target);
        app.setSettlerCmd(pid, app.subWinData.scmd);
        empire.tmp_trs -= app.subWinData.scmd.cost();
        dispZanyosan();
    }
}

function commitSCmd() {
    setSCmd();
    var elm = document.getElementById('selectScmd');
    if (elm) {
        var ary = elm.value.split(/-/);
        dispSCmd(app.subWinData.pid);
        var cmd_id = parseInt(ary[0]);
        if (cmd_id == CMD_ID_SETTLER_MOVE) {
            var e = document.getElementById("subWindow");
            e.style.display = "none";
            app.startSelectMode(app.subWinData.pid, app.subWinData.scmd.empire.nvg);
            return;
        }
    } 
}

function cancelSCmd() {
    var pid = app.subWinData.pid;
    var orgCmd = app.getSettlerCmd(app.subWinData.pid);
    if (orgCmd && orgCmd.empire) {
        orgCmd.empire.tmp_trs += orgCmd.cost();
    }
    app.subWinData.scmd = new CmdNothing(orgCmd.empire);
    app.setSettlerCmd(pid, app.subWinData.scmd);
}

/**
 * 残り予算を表示する.
 */
 function dispZanyosan() {
    var e = document.getElementById("zanyosan");
    e.innerHTML = app.userAgent.empire.tmp_trs;
 }

 /**
  * 移民船団の移動先をクリックしたときのイベント処理
  */
 function clickSelectLoc(loc) {
     app.subWinData.scmd.toloc = loc;
     app.finishSelectMode();
     dispSCmd(app.subWinData.pid);
     var e = document.getElementById("subWindow");
     e.style.display = "block";
 }

 /**
  * 技術を表示する
  */
 function clickDispTec() {
    if (! (app.userAgent) || (! app.userAgent.empire) ) {
        return;
    }
    if (app.selectMode) {
        app.finishSelectMode();
        cancelSCmd();
    }
    app.subWinData.pid = null;

    var e = document.getElementById("subWindow");
    var body =  document.getElementById("subBody");
    var width = 300;
    var height = 300;
    var imgfile = (isIE()) ? "subwin2.gif" : "subwin2.png";
    app.subWinData.width = width;
    app.subWinData.height = height;

    e.style.width = width + "px";
    e.style.height = height + "px";

    var windowTitle = document.getElementById("windowTitle");
    document.getElementById("windowTitleText").innerHTML="技術予算配分";

    var img = document.getElementById("subwinimg");
    img.setAttribute("src", imgfile);
    var str = '<div id="sub_name" style="width: 295px; height: 250px">';
    str += "<table>";
    str += "<tr><td>予算</td><td><span id='yosan'></span></td></tr>";
    str += "<tr><td>総人口</td><td><span id='total_pop'></span></td></tr>";
    str += "<tr><th>技術種類</th><th>現在値</th><th>配分</th></tr>";
    str += "<tr><td>探査技術</td><td align='center'>";
    str += "<span id='TecSearch'></span></td><td align='center'>";
    str += "<span id='TecSearchYosan'></span></td></tr>";
    str += "<tr><td>航宙技術</td><td align='center'>";
    str += "<span id='TecNavigate'></span></td><td align='center'>";
    str += "<span id='TecNavigateYosan'></span></td></tr>";
    str += "<tr><td>軍事技術</td><td align='center'>";
    str += "<span id='TecMiritary'></span></td><td align='center'>";
    str += "<span id='TecMilitaryYosan'></span></td></tr>";
    str += "</table>";
    str += '</div>';
    body.innerHTML = str;
    movingWinInfo.subWindow.disp();

    dispEElement("TecSearch", "fnd");
    dispEElement("TecNavigate", "nvg");
    dispEElement("TecMiritary", "mlt");
    dispEElement("yosan", "trs");
    dispEElementFunc("total_pop", "totalDpl");

    dispTElement("TecSearchYosan", "tecSearch");
    dispTElement("TecNavigateYosan", "tecNavigate");
    dispTElement("TecMilitaryYosan", "tecMilitary");
 }

/**
 * 帝国の属性を表示する
 * @param eid 表示位置elementのid
 * @param ix 表示する属性名
 */
function dispEElement(eid, ix) {
    var empire = app.userAgent.empire;
    var pe = document.getElementById(eid);
    pe.innerHTML = empire[ix];
}

/**
 * 帝国の属性メソッドを呼び出す
 * @param eid 表示位置elementのid
 * @param ix 表示する属性関数名
 */
function dispEElementFunc(eid, ix) {
    var empire = app.userAgent.empire;
    var pe = document.getElementById(eid);
    pe.innerHTML = empire[ix]();
}

function dispTElement(eid, ix) {
    var pe = document.getElementById(eid);
    pe.innerHTML = "<a href='javascript:inputTec(\"" + eid
            + "\", \"" + ix + "\")'>" + app.userAgent[ix].yosan_p + "%</a>";
}

/**
 * 技術をクリックした時（入力開始）の処理
 * @param tec 技術の種類
 */
function inputTec(eid, tec) {
    var pe = document.getElementById(eid);
    var optText = app.userAgent.getTecOptions(tec);
    if (optText == "") {
        return
    }
    var html = "<select onchange='commitTec(\"" + eid + "\", \""
            + tec +  "\")' onblur='commitTec(\"" + eid + "\", \""
            + tec +  "\")' name='tec'>";
    html += optText;
    html += "</select>";
    pe.innerHTML = html;
}

function commitTec(eid, tec) {
    if (document.forms.subForm.tec) {
        var value = document.forms.subForm.tec.value;
        if (value) {
            app.userAgent[tec].yosan_p = parseInt(value);
        }
    }
    dispTElement(eid, tec);
}
